Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4147)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! corrected indentation according to coding standard
+!
+! 4141 2019-08-05 12:24:51Z gronemeier
 ! Initial revision
 !
@@ -59,180 +62,180 @@
 !> @todo Convert variable if type of given values do not fit specified type.
 !--------------------------------------------------------------------------------------------------!
-MODULE data_output_module
-
-   USE kinds
-
-   USE data_output_netcdf4_module, &
-      ONLY: netcdf4_init_dimension, &
-            netcdf4_get_error_message, &
-            netcdf4_stop_file_header_definition, &
-            netcdf4_init_module, &
-            netcdf4_init_variable, &
-            netcdf4_finalize, &
-            netcdf4_open_file, &
-            netcdf4_write_attribute, &
-            netcdf4_write_variable
-
-   USE data_output_binary_module, &
-      ONLY: binary_finalize, &
-            binary_get_error_message, &
-            binary_init_dimension, &
-            binary_stop_file_header_definition, &
-            binary_init_module, &
-            binary_init_variable, &
-            binary_open_file, &
-            binary_write_attribute, &
-            binary_write_variable
-
-   IMPLICIT NONE
-
-   INTEGER, PARAMETER ::  charlen = 100  !< maximum length of character variables
-   INTEGER, PARAMETER ::  no_id = -1     !< default ID if no ID was assigned
-
-   TYPE attribute_type
-      CHARACTER(LEN=charlen) ::  data_type = ''  !< data type
-      CHARACTER(LEN=charlen) ::  name            !< attribute name
-      CHARACTER(LEN=charlen) ::  value_char      !< attribute value if character
-      INTEGER(KIND=1)        ::  value_int8      !< attribute value if 8bit integer
-      INTEGER(KIND=2)        ::  value_int16     !< attribute value if 16bit integer
-      INTEGER(KIND=4)        ::  value_int32     !< attribute value if 32bit integer
-      REAL(KIND=4)           ::  value_real32    !< attribute value if 32bit real
-      REAL(KIND=8)           ::  value_real64    !< attribute value if 64bit real
-   END TYPE attribute_type
-
-   TYPE variable_type
-      CHARACTER(LEN=charlen)                            ::  data_type = ''       !< data type
-      CHARACTER(LEN=charlen)                            ::  name                 !< variable name
-      INTEGER                                           ::  id = no_id           !< id within file
-      LOGICAL                                           ::  is_global = .FALSE.  !< true if global variable
-      CHARACTER(LEN=charlen), DIMENSION(:), ALLOCATABLE ::  dimension_names      !< list of dimension names used by variable
-      INTEGER,                DIMENSION(:), ALLOCATABLE ::  dimension_ids        !< list of dimension ids used by variable
-      TYPE(attribute_type),   DIMENSION(:), ALLOCATABLE ::  attributes           !< list of attributes
-   END TYPE variable_type
-
-   TYPE dimension_type
-      CHARACTER(LEN=charlen)                     ::  data_type = ''        !< data type
-      CHARACTER(LEN=charlen)                     ::  name                  !< dimension name
-      INTEGER                                    ::  id = no_id            !< dimension id within file
-      INTEGER                                    ::  length                !< length of dimension
-      INTEGER                                    ::  length_mask           !< length of masked dimension
-      INTEGER                                    ::  variable_id = no_id   !< associated variable id within file
-      LOGICAL                                    ::  is_masked = .FALSE.   !< true if masked
-      INTEGER,         DIMENSION(2)              ::  bounds                !< lower and upper bound of dimension
-      INTEGER,         DIMENSION(:), ALLOCATABLE ::  masked_indices        !< list of masked indices of dimension
-      INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE ::  masked_values_int8    !< masked dimension values if 16bit integer
-      INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE ::  masked_values_int16   !< masked dimension values if 16bit integer
-      INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE ::  masked_values_int32   !< masked dimension values if 32bit integer
-      INTEGER(iwp),    DIMENSION(:), ALLOCATABLE ::  masked_values_intwp   !< masked dimension values if working-precision int
-      INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE ::  values_int8           !< dimension values if 16bit integer
-      INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE ::  values_int16          !< dimension values if 16bit integer
-      INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE ::  values_int32          !< dimension values if 32bit integer
-      INTEGER(iwp),    DIMENSION(:), ALLOCATABLE ::  values_intwp          !< dimension values if working-precision integer
-      LOGICAL,         DIMENSION(:), ALLOCATABLE ::  mask                  !< mask
-      REAL(KIND=4),    DIMENSION(:), ALLOCATABLE ::  masked_values_real32  !< masked dimension values if 32bit real
-      REAL(KIND=8),    DIMENSION(:), ALLOCATABLE ::  masked_values_real64  !< masked dimension values if 64bit real
-      REAL(wp),        DIMENSION(:), ALLOCATABLE ::  masked_values_realwp  !< masked dimension values if working-precision real
-      REAL(KIND=4),    DIMENSION(:), ALLOCATABLE ::  values_real32         !< dimension values if 32bit real
-      REAL(KIND=8),    DIMENSION(:), ALLOCATABLE ::  values_real64         !< dimension values if 64bit real
-      REAL(wp),        DIMENSION(:), ALLOCATABLE ::  values_realwp         !< dimension values if working-precision real
-      TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  attributes       !< list of attributes
-   END TYPE dimension_type
-
-   TYPE file_type
-      CHARACTER(LEN=charlen)                          ::  format = ''        !< file format
-      CHARACTER(LEN=charlen)                          ::  name = ''          !< file name
-      INTEGER                                         ::  id = no_id         !< id of file
-      LOGICAL                                         ::  is_init = .FALSE.  !< true if initialized
-      TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  attributes         !< list of attributes
-      TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimensions         !< list of dimensions
-      TYPE(variable_type),  DIMENSION(:), ALLOCATABLE ::  variables          !< list of variables
-   END TYPE file_type
-
-
-   CHARACTER(LEN=charlen) ::  output_file_suffix = ''      !< file suffix added to each file name
-   CHARACTER(LEN=800)     ::  internal_error_message = ''  !< string containing the last error message
-   CHARACTER(LEN=800)     ::  temp_string                  !< dummy string
-
-   INTEGER ::  debug_output_unit  !< Fortran Unit Number of the debug-output file
-   INTEGER ::  nfiles = 0         !< number of files
-   INTEGER ::  master_rank = 0    !< master rank for tasks to be executed by single PE only
-   INTEGER ::  output_group_comm  !< MPI communicator addressing all MPI ranks which participate in output
-
-   LOGICAL ::  print_debug_output = .FALSE.  !< if true, debug output is printed
-
-   TYPE(file_type), DIMENSION(:), ALLOCATABLE ::  files  !< file list
-
-   SAVE
-
-   PRIVATE
-
-   !> Initialize the data-output module
-   INTERFACE dom_init
-      MODULE PROCEDURE dom_init
-   END INTERFACE dom_init
-
-   !> Add files to database
-   INTERFACE dom_def_file
-      MODULE PROCEDURE dom_def_file
-   END INTERFACE dom_def_file
-
-   !> Add dimensions to database
-   INTERFACE dom_def_dim
-      MODULE PROCEDURE dom_def_dim
-   END INTERFACE dom_def_dim
-
-   !> Add variables to database
-   INTERFACE dom_def_var
-      MODULE PROCEDURE dom_def_var
-   END INTERFACE dom_def_var
-
-   !> Add attributes to database
-   INTERFACE dom_def_att
-      MODULE PROCEDURE dom_def_att_char
-      MODULE PROCEDURE dom_def_att_int8
-      MODULE PROCEDURE dom_def_att_int16
-      MODULE PROCEDURE dom_def_att_int32
-      MODULE PROCEDURE dom_def_att_real32
-      MODULE PROCEDURE dom_def_att_real64
-   END INTERFACE dom_def_att
-
-   !> Prepare for output: evaluate database and create files
-   INTERFACE dom_def_end
-      MODULE PROCEDURE dom_def_end
-   END INTERFACE dom_def_end
-
-   !> Write variables to file
-   INTERFACE dom_write_var
-      MODULE PROCEDURE dom_write_var
-   END INTERFACE dom_write_var
-
-   !> Last actions required for output befor termination
-   INTERFACE dom_finalize_output
-      MODULE PROCEDURE dom_finalize_output
-   END INTERFACE dom_finalize_output
-
-   !> Return error message
-   INTERFACE dom_get_error_message
-      MODULE PROCEDURE dom_get_error_message
-   END INTERFACE dom_get_error_message
-
-   !> Write database to debug output
-   INTERFACE dom_database_debug_output
-      MODULE PROCEDURE dom_database_debug_output
-   END INTERFACE dom_database_debug_output
-
-   PUBLIC &
-      dom_init, &
-      dom_def_file, &
-      dom_def_dim, &
-      dom_def_var, &
-      dom_def_att, &
-      dom_def_end, &
-      dom_write_var, &
-      dom_finalize_output, &
-      dom_get_error_message, &
-      dom_database_debug_output
-
-CONTAINS
+ MODULE data_output_module
+
+    USE kinds
+
+    USE data_output_netcdf4_module, &
+       ONLY: netcdf4_init_dimension, &
+             netcdf4_get_error_message, &
+             netcdf4_stop_file_header_definition, &
+             netcdf4_init_module, &
+             netcdf4_init_variable, &
+             netcdf4_finalize, &
+             netcdf4_open_file, &
+             netcdf4_write_attribute, &
+             netcdf4_write_variable
+
+    USE data_output_binary_module, &
+       ONLY: binary_finalize, &
+             binary_get_error_message, &
+             binary_init_dimension, &
+             binary_stop_file_header_definition, &
+             binary_init_module, &
+             binary_init_variable, &
+             binary_open_file, &
+             binary_write_attribute, &
+             binary_write_variable
+
+    IMPLICIT NONE
+
+    INTEGER, PARAMETER ::  charlen = 100  !< maximum length of character variables
+    INTEGER, PARAMETER ::  no_id = -1     !< default ID if no ID was assigned
+
+    TYPE attribute_type
+       CHARACTER(LEN=charlen) ::  data_type = ''  !< data type
+       CHARACTER(LEN=charlen) ::  name            !< attribute name
+       CHARACTER(LEN=charlen) ::  value_char      !< attribute value if character
+       INTEGER(KIND=1)        ::  value_int8      !< attribute value if 8bit integer
+       INTEGER(KIND=2)        ::  value_int16     !< attribute value if 16bit integer
+       INTEGER(KIND=4)        ::  value_int32     !< attribute value if 32bit integer
+       REAL(KIND=4)           ::  value_real32    !< attribute value if 32bit real
+       REAL(KIND=8)           ::  value_real64    !< attribute value if 64bit real
+    END TYPE attribute_type
+
+    TYPE variable_type
+       CHARACTER(LEN=charlen)                            ::  data_type = ''       !< data type
+       CHARACTER(LEN=charlen)                            ::  name                 !< variable name
+       INTEGER                                           ::  id = no_id           !< id within file
+       LOGICAL                                           ::  is_global = .FALSE.  !< true if global variable
+       CHARACTER(LEN=charlen), DIMENSION(:), ALLOCATABLE ::  dimension_names      !< list of dimension names used by variable
+       INTEGER,                DIMENSION(:), ALLOCATABLE ::  dimension_ids        !< list of dimension ids used by variable
+       TYPE(attribute_type),   DIMENSION(:), ALLOCATABLE ::  attributes           !< list of attributes
+    END TYPE variable_type
+
+    TYPE dimension_type
+       CHARACTER(LEN=charlen)                     ::  data_type = ''        !< data type
+       CHARACTER(LEN=charlen)                     ::  name                  !< dimension name
+       INTEGER                                    ::  id = no_id            !< dimension id within file
+       INTEGER                                    ::  length                !< length of dimension
+       INTEGER                                    ::  length_mask           !< length of masked dimension
+       INTEGER                                    ::  variable_id = no_id   !< associated variable id within file
+       LOGICAL                                    ::  is_masked = .FALSE.   !< true if masked
+       INTEGER,         DIMENSION(2)              ::  bounds                !< lower and upper bound of dimension
+       INTEGER,         DIMENSION(:), ALLOCATABLE ::  masked_indices        !< list of masked indices of dimension
+       INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE ::  masked_values_int8    !< masked dimension values if 16bit integer
+       INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE ::  masked_values_int16   !< masked dimension values if 16bit integer
+       INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE ::  masked_values_int32   !< masked dimension values if 32bit integer
+       INTEGER(iwp),    DIMENSION(:), ALLOCATABLE ::  masked_values_intwp   !< masked dimension values if working-precision int
+       INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE ::  values_int8           !< dimension values if 16bit integer
+       INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE ::  values_int16          !< dimension values if 16bit integer
+       INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE ::  values_int32          !< dimension values if 32bit integer
+       INTEGER(iwp),    DIMENSION(:), ALLOCATABLE ::  values_intwp          !< dimension values if working-precision integer
+       LOGICAL,         DIMENSION(:), ALLOCATABLE ::  mask                  !< mask
+       REAL(KIND=4),    DIMENSION(:), ALLOCATABLE ::  masked_values_real32  !< masked dimension values if 32bit real
+       REAL(KIND=8),    DIMENSION(:), ALLOCATABLE ::  masked_values_real64  !< masked dimension values if 64bit real
+       REAL(wp),        DIMENSION(:), ALLOCATABLE ::  masked_values_realwp  !< masked dimension values if working-precision real
+       REAL(KIND=4),    DIMENSION(:), ALLOCATABLE ::  values_real32         !< dimension values if 32bit real
+       REAL(KIND=8),    DIMENSION(:), ALLOCATABLE ::  values_real64         !< dimension values if 64bit real
+       REAL(wp),        DIMENSION(:), ALLOCATABLE ::  values_realwp         !< dimension values if working-precision real
+       TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  attributes       !< list of attributes
+    END TYPE dimension_type
+
+    TYPE file_type
+       CHARACTER(LEN=charlen)                          ::  format = ''        !< file format
+       CHARACTER(LEN=charlen)                          ::  name = ''          !< file name
+       INTEGER                                         ::  id = no_id         !< id of file
+       LOGICAL                                         ::  is_init = .FALSE.  !< true if initialized
+       TYPE(attribute_type), DIMENSION(:), ALLOCATABLE ::  attributes         !< list of attributes
+       TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimensions         !< list of dimensions
+       TYPE(variable_type),  DIMENSION(:), ALLOCATABLE ::  variables          !< list of variables
+    END TYPE file_type
+
+
+    CHARACTER(LEN=charlen) ::  output_file_suffix = ''      !< file suffix added to each file name
+    CHARACTER(LEN=800)     ::  internal_error_message = ''  !< string containing the last error message
+    CHARACTER(LEN=800)     ::  temp_string                  !< dummy string
+
+    INTEGER ::  debug_output_unit  !< Fortran Unit Number of the debug-output file
+    INTEGER ::  nfiles = 0         !< number of files
+    INTEGER ::  master_rank = 0    !< master rank for tasks to be executed by single PE only
+    INTEGER ::  output_group_comm  !< MPI communicator addressing all MPI ranks which participate in output
+
+    LOGICAL ::  print_debug_output = .FALSE.  !< if true, debug output is printed
+
+    TYPE(file_type), DIMENSION(:), ALLOCATABLE ::  files  !< file list
+
+    SAVE
+
+    PRIVATE
+
+    !> Initialize the data-output module
+    INTERFACE dom_init
+       MODULE PROCEDURE dom_init
+    END INTERFACE dom_init
+
+    !> Add files to database
+    INTERFACE dom_def_file
+       MODULE PROCEDURE dom_def_file
+    END INTERFACE dom_def_file
+
+    !> Add dimensions to database
+    INTERFACE dom_def_dim
+       MODULE PROCEDURE dom_def_dim
+    END INTERFACE dom_def_dim
+
+    !> Add variables to database
+    INTERFACE dom_def_var
+       MODULE PROCEDURE dom_def_var
+    END INTERFACE dom_def_var
+
+    !> Add attributes to database
+    INTERFACE dom_def_att
+       MODULE PROCEDURE dom_def_att_char
+       MODULE PROCEDURE dom_def_att_int8
+       MODULE PROCEDURE dom_def_att_int16
+       MODULE PROCEDURE dom_def_att_int32
+       MODULE PROCEDURE dom_def_att_real32
+       MODULE PROCEDURE dom_def_att_real64
+    END INTERFACE dom_def_att
+
+    !> Prepare for output: evaluate database and create files
+    INTERFACE dom_def_end
+       MODULE PROCEDURE dom_def_end
+    END INTERFACE dom_def_end
+
+    !> Write variables to file
+    INTERFACE dom_write_var
+       MODULE PROCEDURE dom_write_var
+    END INTERFACE dom_write_var
+
+    !> Last actions required for output befor termination
+    INTERFACE dom_finalize_output
+       MODULE PROCEDURE dom_finalize_output
+    END INTERFACE dom_finalize_output
+
+    !> Return error message
+    INTERFACE dom_get_error_message
+       MODULE PROCEDURE dom_get_error_message
+    END INTERFACE dom_get_error_message
+
+    !> Write database to debug output
+    INTERFACE dom_database_debug_output
+       MODULE PROCEDURE dom_database_debug_output
+    END INTERFACE dom_database_debug_output
+
+    PUBLIC &
+       dom_init, &
+       dom_def_file, &
+       dom_def_dim, &
+       dom_def_var, &
+       dom_def_att, &
+       dom_def_end, &
+       dom_write_var, &
+       dom_finalize_output, &
+       dom_get_error_message, &
+       dom_database_debug_output
+
+ CONTAINS
 
 
@@ -247,34 +250,34 @@
 !> prevents that multiple groups try to open and write to the same output file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE dom_init( file_suffix_of_output_group, mpi_comm_of_output_group, master_output_rank, &
-                     program_debug_output_unit, debug_output )
-
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  file_suffix_of_output_group  !< file-name suffix added to each file;
-                                                                           !> must be unique for each output group
-
-   INTEGER, INTENT(IN), OPTIONAL ::  master_output_rank         !< MPI rank executing tasks which must
-                                                                !> be executed by a single PE only
-   INTEGER, INTENT(IN)           ::  mpi_comm_of_output_group   !< MPI communicator specifying the MPI group
-                                                                !> which participate in the output
-   INTEGER, INTENT(IN)           ::  program_debug_output_unit  !< file unit number for debug output
-
-   LOGICAL, INTENT(IN)           ::  debug_output               !< if true, debug output is printed
-
-
-   IF ( PRESENT( file_suffix_of_output_group ) )  output_file_suffix = file_suffix_of_output_group
-   IF ( PRESENT( master_output_rank ) )  master_rank = master_output_rank
-
-   output_group_comm = mpi_comm_of_output_group
-
-   debug_output_unit = program_debug_output_unit
-   print_debug_output = debug_output
-
-   CALL binary_init_module( output_file_suffix, output_group_comm, master_rank, &
-                            debug_output_unit, debug_output, no_id )
-
-   CALL netcdf4_init_module( output_file_suffix, output_group_comm, master_rank, &
-                            debug_output_unit, debug_output, no_id )
-
-END SUBROUTINE dom_init
+ SUBROUTINE dom_init( file_suffix_of_output_group, mpi_comm_of_output_group, master_output_rank, &
+                      program_debug_output_unit, debug_output )
+
+    CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  file_suffix_of_output_group  !< file-name suffix added to each file;
+                                                                            !> must be unique for each output group
+
+    INTEGER, INTENT(IN), OPTIONAL ::  master_output_rank         !< MPI rank executing tasks which must
+                                                                 !> be executed by a single PE only
+    INTEGER, INTENT(IN)           ::  mpi_comm_of_output_group   !< MPI communicator specifying the MPI group
+                                                                 !> which participate in the output
+    INTEGER, INTENT(IN)           ::  program_debug_output_unit  !< file unit number for debug output
+
+    LOGICAL, INTENT(IN)           ::  debug_output               !< if true, debug output is printed
+
+
+    IF ( PRESENT( file_suffix_of_output_group ) )  output_file_suffix = file_suffix_of_output_group
+    IF ( PRESENT( master_output_rank ) )  master_rank = master_output_rank
+
+    output_group_comm = mpi_comm_of_output_group
+
+    debug_output_unit = program_debug_output_unit
+    print_debug_output = debug_output
+
+    CALL binary_init_module( output_file_suffix, output_group_comm, master_rank, &
+                             debug_output_unit, debug_output, no_id )
+
+    CALL netcdf4_init_module( output_file_suffix, output_group_comm, master_rank, &
+                             debug_output_unit, debug_output, no_id )
+
+ END SUBROUTINE dom_init
 
 !--------------------------------------------------------------------------------------------------!
@@ -285,60 +288,61 @@
 !>   status = dom_def_file( 'my_output_file_name', 'binary' )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_file( file_name, file_format ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< name of file to be created
-   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< format of file to be created
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_file'  !< name of this routine
-
-   INTEGER ::  f             !< loop index
-   INTEGER ::  return_value  !< return value
-
-   TYPE(file_type), DIMENSION(:), ALLOCATABLE ::  files_tmp  !< temporary file list
-
-
-   return_value = 0
-
-   CALL internal_message( 'debug', routine_name // ': define file "' // TRIM( file_name ) // '"' )
-
-   !-- Allocate file list or extend it by 1
-   IF ( .NOT. ALLOCATED( files ) ) THEN
-
-      nfiles = 1
-      ALLOCATE( files(nfiles) )
-
-   ELSE
-
-      nfiles = SIZE( files )
-      !-- Check if file already exists
-      DO  f = 1, nfiles
-         IF ( files(f)%name == TRIM( file_name ) )  THEN
-            return_value = 1
-            CALL internal_message( 'error', routine_name // &
-                    ': file "' // TRIM( file_name ) // '" already exists' )
-            EXIT
-         ENDIF
-      ENDDO
-
-      !-- Extend file list
-      IF ( return_value == 0 )  THEN
-         ALLOCATE( files_tmp(nfiles) )
-         files_tmp = files
-         DEALLOCATE( files )
-         nfiles = nfiles + 1
-         ALLOCATE( files(nfiles) )
-         files(:nfiles-1) = files_tmp
-         DEALLOCATE( files_tmp )
-      ENDIF
-
-   ENDIF
-
-   !-- Add new file to database
-   IF ( return_value == 0 )  THEN
-      files(nfiles)%name = TRIM( file_name )
-      files(nfiles)%format = TRIM( file_format )
-   ENDIF
-
-END FUNCTION dom_def_file
+ FUNCTION dom_def_file( file_name, file_format ) RESULT( return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< name of file to be created
+    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< format of file to be created
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_file'  !< name of this routine
+
+    INTEGER ::  f             !< loop index
+    INTEGER ::  return_value  !< return value
+
+    TYPE(file_type), DIMENSION(:), ALLOCATABLE ::  files_tmp  !< temporary file list
+
+
+    return_value = 0
+
+    CALL internal_message( 'debug', routine_name // ': define file "' // TRIM( file_name ) // '"' )
+!
+!-- Allocate file list or extend it by 1
+    IF ( .NOT. ALLOCATED( files ) ) THEN
+
+       nfiles = 1
+       ALLOCATE( files(nfiles) )
+
+    ELSE
+
+       nfiles = SIZE( files )
+!
+!--    Check if file already exists
+       DO  f = 1, nfiles
+          IF ( files(f)%name == TRIM( file_name ) )  THEN
+             return_value = 1
+             CALL internal_message( 'error', routine_name // &
+                     ': file "' // TRIM( file_name ) // '" already exists' )
+             EXIT
+          ENDIF
+       ENDDO
+!
+!--    Extend file list
+       IF ( return_value == 0 )  THEN
+          ALLOCATE( files_tmp(nfiles) )
+          files_tmp = files
+          DEALLOCATE( files )
+          nfiles = nfiles + 1
+          ALLOCATE( files(nfiles) )
+          files(:nfiles-1) = files_tmp
+          DEALLOCATE( files_tmp )
+       ENDIF
+
+    ENDIF
+!
+!-- Add new file to database
+    IF ( return_value == 0 )  THEN
+       files(nfiles)%name = TRIM( file_name )
+       files(nfiles)%format = TRIM( file_format )
+    ENDIF
+
+ END FUNCTION dom_def_file
 
 !--------------------------------------------------------------------------------------------------!
